Skip to content
Start here

Create downloads

client.Stream.Downloads.New(ctx, identifier, body) (*DownloadNewResponse, error)
POST/accounts/{account_id}/stream/{identifier}/downloads

Creates a download for a video when a video is ready to view. Use /downloads/{download_type} instead for type-specific downloads. Available types are default and audio.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
ParametersExpand Collapse
identifier string

A Cloudflare-generated unique identifier for a media item.

maxLength32
body DownloadNewParams
AccountID param.Field[string]Optional

Identifier.

maxLength32
ReturnsExpand Collapse
type DownloadNewResponse struct{…}

An object with download type keys. Each key is optional and only present if that download type has been created.

Audio DownloadNewResponseAudioOptional

The audio-only download. Only present if this download type has been created.

PercentComplete float64

Indicates the progress as a percentage between 0 and 100.

maximum100
minimum0
Status DownloadNewResponseAudioStatus

The status of a generated download.

One of the following:
const DownloadNewResponseAudioStatusReady DownloadNewResponseAudioStatus = "ready"
const DownloadNewResponseAudioStatusInprogress DownloadNewResponseAudioStatus = "inprogress"
const DownloadNewResponseAudioStatusError DownloadNewResponseAudioStatus = "error"
URL stringOptional

The URL to access the generated download.

formaturi
Default DownloadNewResponseDefaultOptional

The default video download. Only present if this download type has been created.

PercentComplete float64

Indicates the progress as a percentage between 0 and 100.

maximum100
minimum0
Status DownloadNewResponseDefaultStatus

The status of a generated download.

One of the following:
const DownloadNewResponseDefaultStatusReady DownloadNewResponseDefaultStatus = "ready"
const DownloadNewResponseDefaultStatusInprogress DownloadNewResponseDefaultStatus = "inprogress"
const DownloadNewResponseDefaultStatusError DownloadNewResponseDefaultStatus = "error"
URL stringOptional

The URL to access the generated download.

formaturi

Create downloads

package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/option"
  "github.com/cloudflare/cloudflare-go/stream"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  download, err := client.Stream.Downloads.New(
    context.TODO(),
    "ea95132c15732412d22c1476fa83f27a",
    stream.DownloadNewParams{
      AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", download.Audio)
}
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "audio": {
      "percentComplete": 0,
      "status": "ready",
      "url": "https://customer-m033z5x00ks6nunl.cloudflarestream.com/ea95132c15732412d22c1476fa83f27a/downloads/default.mp4"
    },
    "default": {
      "percentComplete": 0,
      "status": "ready",
      "url": "https://customer-m033z5x00ks6nunl.cloudflarestream.com/ea95132c15732412d22c1476fa83f27a/downloads/default.mp4"
    }
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "audio": {
      "percentComplete": 0,
      "status": "ready",
      "url": "https://customer-m033z5x00ks6nunl.cloudflarestream.com/ea95132c15732412d22c1476fa83f27a/downloads/default.mp4"
    },
    "default": {
      "percentComplete": 0,
      "status": "ready",
      "url": "https://customer-m033z5x00ks6nunl.cloudflarestream.com/ea95132c15732412d22c1476fa83f27a/downloads/default.mp4"
    }
  }
}